***********************************************************
// This function should be called after every function that accesses
// the SQL database. For example:
//   LOCAL progname := "fstest"
//   nRowCount := sql_ret(cRelname, cWclause , @cTfilename, @nFieldCount)
//   sql_error( nRowCount, progname, "sql_ret" )
//
//   Compile: FlagShip sql_error.prg -m -c
//
#include "fileio.fh"

FUNCTION sql_error(RetVal, progname, command )
LOCAL buff
IF RetVal < 0
  CLEAR SCREEN
  ?? CHR(7)
  DO CASE
   CASE RetVal == -179
     @ 10, 10 SAY "An SQL lock timeout error has occured."
     @ 12, 10 SAY "Another user has locked a record that you need."
     @ 13, 10 SAY "Please wait a short period, then try this function"
     @ 14, 10 SAY "again."
   OTHERWISE
     @ 10, 10 SAY "An SQL error has occured."     
     @ 12, 10 SAY "Please make a note of what you were doing just before"
     @ 13, 10 SAY "this error occured. Then notify your supervisor or"
     @ 14, 10 SAY "the System Administrator of this error."
  ENDCASE

  LOCAL logname := NETNAME()
  LOCAL today := DTOC( DATE() )

  // This is the file that will be your error log. Edit to suit your
  // system.
  LOCAL handle := FOPEN( "/home/griffin/SQLkit/.jlt_error.log", FO_WRITE )
  FSEEK( handle, 0, FS_END )
  buff := progname + " " + today + " " + logname + " " + STR(RetVal) + ;
                " " + command + CHR(10)
  FWRITE( handle, buff )
  FCLOSE( handle )
  ? ; ? ; ? ; ?
  WAIT
  QUIT
ENDIF
RETURN NIL

***************************************************************
  
